package main

import (
	"fmt"
	"io"
	"log"
	"os"
)

func main() {
	if err := run(); err != nil {
		log.Fatal(err)
	}

}

const (
	docFile   = "./doc.go"
	usageFile = "./data/usage.txt"
)

func run() error {
	doc, err := os.OpenFile(docFile, os.O_RDWR|os.O_CREATE, 0644)
	if err != nil {
		return fmt.Errorf("could not open file %s: %w", docFile, err)
	}

	usage, err := os.Open(usageFile)
	if err != nil {
		return fmt.Errorf("could not open file %s: %w", usageFile, err)
	}
	if _, err := doc.WriteString("// Code generated by cmd/support/generate/main.go, DO NOT EDIT.\n\n"); err != nil {
		return err
	}

	if _, err := doc.WriteString("/*\n\n"); err != nil {
		return err
	}

	if _, err := io.Copy(doc, usage); err != nil {
		return err
	}
	if _, err := doc.WriteString("\n*/\n"); err != nil {
		return err
	}
	if _, err := doc.WriteString("package main\n"); err != nil {
		return err
	}

	return nil
}
